unit mdfType;
interface
const
{== system tables ==}

 id_sysobjects          = $01;  id_sysindexes          = $02;
 id_syscolumns          = $03;  id_systypes            = $04;
 id_syscomments         = $06;  id_sysfiles1           = $08;
 id_syspermissions      = $09;  id_sysusers            = $0A;
 id_sysproperties       = $0B;  id_sysdepends          = $0C;
 id_sysreferences       = $0E;  id_syfulltextcatalogs  = $13;
 id_sysindexkeys        = $14;  id_sysforeignkeys      = $15;
 id_sysmembers          = $16;  id_sysprotects         = $17;
 id_sysfulltextnotify   = $18;  id_sysdatabases        = $1E;
 id_sysperfinfo         = $1F;  id_sysprocesses        = $20;
 id_sysxlogins          = $21;  id_syslocks            = $22;
 id_sysdevices          = $23;  id_sysmessages         = $24;
 id_sysconfigures       = $25;  id_syscurconfigs       = $26;
 id_sysservers          = $28;  id_syslockinfo         = $29;
 id_syslanguages        = $2C;  id_syscharsets         = $2D;
 id_syscursorrefs       = $33;  id_syscursors          = $34;
 id_syscursorcolumns    = $35;  id_syscursortables     = $36;
 id_syscacheobjects     = $37;  id_sysaltfiles         = $5E;
 id_sysfiles            = $5F;  id_sysfilegroups       = $60;
 id_sysallocations      = $62;  id_allocation          = $63;

 id_system_objects      = $0FFFFFE7C;

{== from WinFS ==}
{
 id_sysrowsets          = $05;
 id_sysallocunits       = $07; 
 id_syshobtcolumns      = $0D; 
 id_syshobts            = $0F;
 id_sysftinds           = $19;
 id_sysserefs           = $1A;
 id_sysowners           = $1B; 
 id_sysdbreg            = $1C;
 id_sysprivs            = $1D;
 id_syslogshippers      = $27;
 id_syscerts            = $2E; 
 id_sysrmtlgns          = $2F;
 id_syslnklgns          = $30;
 id_sysscalartypes      = $32;
 id_syshttpendpts       = $38; 
 id_syshttpmethods      = $39;
 id_sysbinobjs          = $3A;
 id_sysobjvalues        = $3C;
 id_sysrowsetrefs       = $41;
 id_sysdexmit           = $42;
 id_sysremsvcbinds      = $43;
 id_sysrts              = $45;
 id_sysclsobjs          = $46;
 id_sysdesend           = $48;
 id_sysdercv            = $49; 
 id_sysmultiobjrefs     = $4B; 
 id_sysdbfiles          = $4C; 
 id_sysfsfiles          = $4D;
 id_sysguidrefs         = $4E;
 id_sysqnames           = $5A; 
}
{== standart types ==}
 type_bigint            = $07F; type_binary            = $0AD;
 type_bit               = $068; type_char              = $0AF;
 type_datetime          = $03D; type_decimal           = $06A;
 type_float             = $03E; type_image             = $022;
 type_int               = $038; type_money             = $03C;
 type_nchar             = $0EF; type_ntext             = $063;
 type_numeric           = $06C; type_nvarchar          = $0E7;
 type_real              = $03B; type_smalldatetime     = $03A;
 type_smallint          = $034; type_smallmoney        = $07A;
 type_sql_variant       = $062; type_sysname           = $0E7;
 type_text              = $023; type_timestamp         = $0BD;
 type_tinyint           = $030; type_uniqueidentifier  = $024;
 type_varbinary         = $0A5; type_varchar           = $0A7;

{== object types ==}
 obj_AP = $05041;  obj_C  = $02043;  obj_D  = $02044;
 obj_F  = $02046;  obj_FN = $04E46;  obj_IF = $04649;
 obj_L  = $0204C;  obj_P  = $02050;  obj_PK = $04B50;
 obj_R  = $02052;  obj_RF = $04652;  obj_S  = $02053;
 obj_TF = $04654;  obj_TR = $05254;  obj_U  = $02055;
 obj_UQ = $05155;  obj_V  = $02056;  obj_X  = $02058;

implementation
end.